aboutsummaryrefslogtreecommitdiff
path: root/board/raspberrypi
diff options
context:
space:
mode:
authorGravatar Gaël PORTAY <gael.portay@savoirfairelinux.com>2017-04-18 11:59:59 -0400
committerGravatar Peter Korsgaard <peter@korsgaard.com>2017-05-04 09:25:20 +0200
commit9bbea36e3e6f27475dd8589f087522745aa39aa5 (patch)
tree5ef1d5cae74257a19fb13ee99f6ace193991ba26 /board/raspberrypi
parent634655b6281047f5fe2a2b09b95aa642144d23a1 (diff)
downloadbuildroot-9bbea36e3e6f27475dd8589f087522745aa39aa5.tar.gz
buildroot-9bbea36e3e6f27475dd8589f087522745aa39aa5.tar.bz2
configs: add raspberrypi3 64bits defconfig
This configuration builds a 64bit image for RaspberryPi 3. The size of the ext4 filesystem has to be extended to fit the large amount (~60MB) of kernel modules enabled in the defconfig. [Peter: drop gcc version selection / glibc, explain ext4 size requirement] Signed-off-by: Gaël PORTAY <gael.portay@savoirfairelinux.com> Tested-by: Ricardo Martincoski <ricardo.martincoski@gmail.com> Signed-off-by: Peter Korsgaard <peter@korsgaard.com>
Diffstat (limited to 'board/raspberrypi')
-rw-r--r--board/raspberrypi/genimage-raspberrypi3-64.cfg31
-rwxr-xr-xboard/raspberrypi/post-image.sh20
2 files changed, 51 insertions, 0 deletions
diff --git a/board/raspberrypi/genimage-raspberrypi3-64.cfg b/board/raspberrypi/genimage-raspberrypi3-64.cfg
new file mode 100644
index 0000000000..c5f86527d0
--- /dev/null
+++ b/board/raspberrypi/genimage-raspberrypi3-64.cfg
@@ -0,0 +1,31 @@
+image boot.vfat {
+ vfat {
+ files = {
+ "bcm2710-rpi-3-b.dtb",
+ "bcm2837-rpi-3-b.dtb",
+ "rpi-firmware/bootcode.bin",
+ "rpi-firmware/cmdline.txt",
+ "rpi-firmware/config.txt",
+ "rpi-firmware/fixup.dat",
+ "rpi-firmware/start.elf",
+ "Image"
+ }
+ }
+ size = 32M
+}
+
+image sdcard.img {
+ hdimage {
+ }
+
+ partition boot {
+ partition-type = 0xC
+ bootable = "true"
+ image = "boot.vfat"
+ }
+
+ partition rootfs {
+ partition-type = 0x83
+ image = "rootfs.ext4"
+ }
+}
diff --git a/board/raspberrypi/post-image.sh b/board/raspberrypi/post-image.sh
index b2bb070678..de972998b0 100755
--- a/board/raspberrypi/post-image.sh
+++ b/board/raspberrypi/post-image.sh
@@ -16,6 +16,26 @@ dtoverlay=pi3-miniuart-bt
__EOF__
fi
;;
+ --aarch64)
+ # Run a 64bits kernel (armv8)
+ sed -e '/^kernel=/s,=.*,=Image,' -i "${BINARIES_DIR}/rpi-firmware/config.txt"
+ if ! grep -qE '^arm_control=0x200' "${BINARIES_DIR}/rpi-firmware/config.txt"; then
+ cat << __EOF__ >> "${BINARIES_DIR}/rpi-firmware/config.txt"
+
+# enable 64bits support
+arm_control=0x200
+__EOF__
+ fi
+
+ # Enable uart console
+ if ! grep -qE '^enable_uart=1' "${BINARIES_DIR}/rpi-firmware/config.txt"; then
+ cat << __EOF__ >> "${BINARIES_DIR}/rpi-firmware/config.txt"
+
+# enable rpi3 ttyS0 serial console
+enable_uart=1
+__EOF__
+ fi
+ ;;
esac
rm -rf "${GENIMAGE_TMP}"